unit frmuMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Actions,
  Vcl.ActnList, Vcl.Menus, Vcl.ExtDlgs, System.IOUtils, Vcl.Clipbrd,
  System.RegularExpressions, System.UITypes, Vcl.ComCtrls, WinAPI.ShellAPI,
  Vcl.Printers, System.Math, System.Win.Registry, Vcl.Touch.GestureMgr;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    acNew: TAction;
    acOpen: TAction;
    acSave: TAction;
    acSaveAs: TAction;
    acPageSetup: TAction;
    acPrint: TAction;
    acExit: TAction;
    F1: TMenuItem;
    N1: TMenuItem;
    O1: TMenuItem;
    S1: TMenuItem;
    A1: TMenuItem;
    U1: TMenuItem;
    P1: TMenuItem;
    X1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    OpenTextFileDialog1: TOpenTextFileDialog;
    SaveTextFileDialog1: TSaveTextFileDialog;
    acUndo: TAction;
    acCut: TAction;
    acCopy: TAction;
    acPaste: TAction;
    acDelete: TAction;
    acFind: TAction;
    acFindNext: TAction;
    acReplace: TAction;
    acGoTo: TAction;
    acSelectAll: TAction;
    acTimeDate: TAction;
    E1: TMenuItem;
    U2: TMenuItem;
    N4: TMenuItem;
    C1: TMenuItem;
    T1: TMenuItem;
    P2: TMenuItem;
    L1: TMenuItem;
    N5: TMenuItem;
    F2: TMenuItem;
    N6: TMenuItem;
    R1: TMenuItem;
    G1: TMenuItem;
    N7: TMenuItem;
    A2: TMenuItem;
    D1: TMenuItem;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    acWordwrap: TAction;
    acFont: TAction;
    O2: TMenuItem;
    W1: TMenuItem;
    F3: TMenuItem;
    FontDialog1: TFontDialog;
    acStatusBar: TAction;
    N8: TMenuItem;
    S2: TMenuItem;
    StatusBar1: TStatusBar;
    acHelp: TAction;
    acAbout: TAction;
    H1: TMenuItem;
    H2: TMenuItem;
    A3: TMenuItem;
    N9: TMenuItem;
    PageSetupDialog1: TPageSetupDialog;
    PrintDialog1: TPrintDialog;
    acHeaderFooter: TAction;
    H3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure acUndoExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction; var Handled: Boolean);
    procedure acCutExecute(Sender: TObject);
    procedure acCopyExecute(Sender: TObject);
    procedure acPasteExecute(Sender: TObject);
    procedure E1Click(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure Dialog_Find(Sender: TObject);
    procedure acFindNextExecute(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acReplaceExecute(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure acGoToExecute(Sender: TObject);
    procedure acSelectAllExecute(Sender: TObject);
    procedure acTimeDateExecute(Sender: TObject);
    procedure acWordwrapExecute(Sender: TObject);
    procedure acFontExecute(Sender: TObject);
    procedure StatusBar1Resize(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure acStatusBarExecute(Sender: TObject);
    procedure acHelpExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure acPageSetupExecute(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure acHeaderFooterExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    FFileName: String;
    FEncodingIndex: Integer;
    FHeaderStr: string;
    FFooterStr: string;
    FMarginTop: Integer;
    FMarginBottom: Integer;
    FMarginLeft: Integer;
    FMarginRight: Integer;
    function DetectEncodingFromFile(FileName: string): Integer;
    procedure DispRowCol;
    function GetEditorEncoding: TEncoding;
    function GetTextFileName: string;
    procedure Init(AFileName: string = '');
    procedure PrintText(const HeaderStr, FooterStr: string);
    procedure SaveFile;
    procedure UpdateCaption;
    procedure WmDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  frmuGotoLine,
  frmuHeaderFooter;

procedure TForm1.WmDropFiles(var Msg: TWMDropFiles);
var
  Buf: array [0..MAX_PATH] of Char;
begin
  // hbvꂽ (ŏ) t@C擾
  DragQueryFile(Msg.Drop, 0, Buf, MAX_PATH);
  DragFinish(Msg.Drop);
  // t@Cۑ
  FFileName := StrPas(Buf);
  // GR[fBO𔻒
  FEncodingIndex := DetectEncodingFromFile(FFileName);
  // LvVύX
  UpdateCaption;
  // GR[fBOw肵ēǂݍ
  Memo1.Lines.LoadFromFile(FFileName, GetEditorEncoding);
end;

procedure TForm1.FormCreate(Sender: TObject);
// tH[쐬
begin
  FHeaderStr := '&f';
  FFooterStr := 'y[W(&p)';
  Init;
  DragAcceptFiles(Self.Handle, True);
end;

procedure TForm1.FormShow(Sender: TObject);
// tH[\
var
  FileName, Msg: string;
  ret: Integer;
  reg: TRegistryIniFile;
begin
  Self.OnShow := nil;

  // ݒ̓ǂݍ
  reg := TRegistryIniFile.Create('Software\Notepad_Clone');
  try
    // EBhD̃TCY
    Self.Width  := reg.ReadInteger('', 'iWindowPosDX', 640);
    Self.Height := reg.ReadInteger('', 'iWindowPosDY', 480);

    // EBhD̈ʒu
    Self.Left := reg.ReadInteger('', 'iWindowPosX', (Screen.Width  - Self.Width ) div 2);
    Self.Top  := reg.ReadInteger('', 'iWindowPosY', (Screen.Height - Self.Height) div 2);

    // ̃tHg
    Memo1.Font.Name := reg.ReadString('', 'lfFaceName', 'lr SVbN');
    Memo1.Font.Size := reg.ReadInteger('', 'iPointSize', 120) div 10;

    // [E[Ő܂Ԃ] ̏
    Memo1.WordWrap := Boolean(reg.ReadInteger('', 'fWrap', 0) = 1);
    if Memo1.WordWrap then
      Memo1.ScrollBars := ssVertical;

    // [Xe[^Xo[] ̏
    StatusBar1.Visible := Boolean(reg.ReadInteger('', 'StatusBar', 0) = 1);

    // : wb_[/tb^[
    FHeaderStr := reg.ReadString('', 'szHeader' , '&f');
    FFooterStr := reg.ReadString('', 'szTrailer', 'y[W(&p)');

    // : }[W
    FMarginTop    := reg.ReadInteger('', 'iMarginTop'    , 2000);
    FMarginBottom := reg.ReadInteger('', 'iMarginBottom' , 2000);
    FMarginLeft   := reg.ReadInteger('', 'iMarginLeft'   , 2500);
    FMarginRight  := reg.ReadInteger('', 'iMarginRight'  , 2500);
  finally
    reg.Free;
  end;

  if ParamCount = 0 then
    Exit;

  FileName := ParamStr(1);
  if TFile.Exists(FileName) then
    begin
      // t@C݂
      FFileName := FileName;
      // GR[fBO𔻒
      FEncodingIndex := DetectEncodingFromFile(FFileName);
      // LvVύX
      UpdateCaption;
      // GR[fBOw肵ēǂݍ
      Memo1.Lines.LoadFromFile(FFileName, GetEditorEncoding);
    end
  else
    begin
      // t@C݂Ȃ
      Msg := 't@C %s ܂B' + sLineBreak + sLineBreak + 'V쐬܂?';
      Msg := Format(Msg, [TPath.GetFileName(FileName)]);
      ret := MessageDlg(Msg, TMsgDlgType.mtConfirmation, [mbYes, mbNo, mbCancel], -1);
      case ret of
        ID_YES:    // t@Ct [VK쐬]
          Init(FileName);
        ID_NO:     // [VK쐬] Ɠ...܂AȂ
          ;
        ID_CANCEL: // AvP[V
          PostMessage(Self.Handle, WM_CLOSE, 0, 0);
      end;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
// tH[N[Y
var
  reg: TRegistryIniFile;
begin
  // ݒ̕ۑ
  reg := TRegistryIniFile.Create('Software\Notepad_Clone');
  try
    // EBhD̃TCY
    reg.WriteInteger('', 'iWindowPosDX', Self.Width );
    reg.WriteInteger('', 'iWindowPosDY', Self.Height);

    // EBhD̈ʒu
    reg.WriteInteger('', 'iWindowPosX', Self.Left);
    reg.WriteInteger('', 'iWindowPosY', Self.Top );

    // ̃tHg
    reg.WriteString('', 'lfFaceName',  Memo1.Font.Name);
    reg.WriteInteger('', 'iPointSize', Memo1.Font.Size * 10);

    // [E[Ő܂Ԃ] ̏
    reg.WriteInteger('', 'fWrap', Integer(Memo1.WordWrap));

    // [Xe[^Xo[] ̏
    reg.WriteInteger('', 'StatusBar', Integer(StatusBar1.Visible));

    // : wb_[/tb^[
    reg.WriteString('', 'szHeader' , FHeaderStr);
    reg.WriteString('', 'szTrailer', FFooterStr);

    // : }[W
    reg.WriteInteger('', 'iMarginTop'    , FMarginTop   );
    reg.WriteInteger('', 'iMarginBottom' , FMarginBottom);
    reg.WriteInteger('', 'iMarginLeft'   , FMarginLeft  );
    reg.WriteInteger('', 'iMarginLeft'   , FMarginRight );
  finally
    reg.Free;
  end;
end;

procedure TForm1.StatusBar1Resize(Sender: TObject);
// Xe[^Xo[̃TCY
begin
  StatusBar1.Panels[1].Width := StatusBar1.Width div 4;
  StatusBar1.Panels[0].Width := StatusBar1.Width - StatusBar1.Panels[1].Width;
end;

procedure TForm1.Memo1Click(Sender: TObject);
// Memo1 NbN
begin
  DispRowCol;
end;


procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
// Memo1 L[Abv
begin
  DispRowCol;
end;

// [FILE] Actions

procedure TForm1.acNewExecute(Sender: TObject);
// Action: VK(N)
begin
  Init;
end;

procedure TForm1.acOpenExecute(Sender: TObject);
// Action: J(O)...
begin
  OpenTextFileDialog1.EncodingIndex := FEncodingIndex;
  if OpenTextFileDialog1.Execute then
    begin
      // lۑ
      FFileName := OpenTextFileDialog1.FileName;
      FEncodingIndex := OpenTextFileDialog1.EncodingIndex;
      // LvVύX
      UpdateCaption;
      // GR[fBOw肵ēǂݍ
      Memo1.Lines.LoadFromFile(FFileName, GetEditorEncoding);
    end;
end;

procedure TForm1.acSaveExecute(Sender: TObject);
// Action: ㏑ۑ(S)
begin
  if (FFileName = '') then
    begin
      // Otĕۑ
      acSaveAs.Execute;
    end
  else
    begin
      // ㏑ۑ
      SaveFile;
    end;
end;

procedure TForm1.acSaveAsExecute(Sender: TObject);
// Action: Otĕۑ(A)...
begin
  SaveTextFileDialog1.FileName := FFileName;
  SaveTextFileDialog1.EncodingIndex := FEncodingIndex;
  if SaveTextFileDialog1.Execute then
    begin
      // lۑ
      FFileName := SaveTextFileDialog1.FileName;
      FEncodingIndex := SaveTextFileDialog1.EncodingIndex;
      // LvVύX
      UpdateCaption;
      // t@C֕ۑ
      SaveFile;
    end;
end;

procedure TForm1.acPageSetupExecute(Sender: TObject);
// Action: y[Wݒ(U)...
begin
  PageSetupDialog1.MarginTop    := FMarginTop;
  PageSetupDialog1.MarginBottom := FMarginBottom;
  PageSetupDialog1.MarginLeft   := FMarginLeft;
  PageSetupDialog1.MarginRight  := FMarginRight;
  if PageSetupDialog1.Execute then
    begin
      FMarginTop    := PageSetupDialog1.MarginTop;
      FMarginBottom := PageSetupDialog1.MarginBottom;
      FMarginLeft   := PageSetupDialog1.MarginLeft;
      FMarginRight  := PageSetupDialog1.MarginRight;
    end;
end;

procedure TForm1.acHeaderFooterExecute(Sender: TObject);
// Action: wb_[ƃtb^[(H)
begin
  Form3 := TForm3.Create(Self);
  try
    // wb_[ƃtb^[ Form3 ɓn
    Form3.Edit1.Text := FHeaderStr;
    Form3.Edit2.Text := FFooterStr;
    // Form3 [_ŕ\
    if Form3.ShowModal = mrOK then
      begin
        // [OK] {^ꂽ
        FHeaderStr := Form3.Edit1.Text;
        FFooterStr := Form3.Edit2.Text;
      end;
  finally
    Form3.Free;
  end;
end;

procedure TForm1.acPrintExecute(Sender: TObject);
// Action: (P)
begin
  PrintText(FHeaderStr, FFooterStr);
end;

procedure TForm1.acExitExecute(Sender: TObject);
// Action: ̏I(X)
begin
  Self.Close;
end;

// [EDIT] Actions

procedure TForm1.E1Click(Sender: TObject);
begin
  acDelete.ShortCut := TextToShortCut('Del');
end;

procedure TForm1.acUndoExecute(Sender: TObject);
// Action: ɖ߂(U)
begin
  Memo1.Undo;
end;

procedure TForm1.acCutExecute(Sender: TObject);
// Action: ؂(T)
begin
  Memo1.CutToClipboard;
end;

procedure TForm1.acCopyExecute(Sender: TObject);
// Action: Rs[(C)
begin
  Memo1.CopyToClipboard;
end;

procedure TForm1.acPasteExecute(Sender: TObject);
// Action: \t(P)
begin
  Memo1.PasteFromClipboard;
end;

procedure TForm1.acDeleteExecute(Sender: TObject);
// Action: 폜(L)
begin
  Memo1.ClearSelection;
end;

procedure TForm1.acFindExecute(Sender: TObject);
// Action: (F)
begin
  // _CAOJ
  FindDialog1.Execute;
end;

procedure TForm1.acFindNextExecute(Sender: TObject);
// Action: (N)
begin
  if FindDialog1.FindText = '' then
    acFind.Execute
  else
    Dialog_Find(FindDialog1);
end;

procedure TForm1.acReplaceExecute(Sender: TObject);
// Action: u(H)
begin
  // u_CAOJ
  ReplaceDialog1.Execute;
end;

procedure TForm1.Dialog_Find(Sender: TObject);
// Cxgnh
var
  RegEx: TRegEx;
  Exp, Msg: String;
  Options: TRegExOptions;
  Match, dMatch: TMatch;
  StartPos, EndPos: Integer;
begin
  // 𐳋K\փGXP[v
  Exp := TRegEx.Escape(FindDialog1.FindText);

  // "啶Əʂ" Ƀ`FbNĂȂ
  // IvV roIgnoreCase (啶ʂȂ) ǉ
  if not (frMatchCase in FindDialog1.Options) then
    Include(Options, roIgnoreCase);

  // K\IuWFNg̐
  RegEx := TRegEx.Create(Exp, Options);

  if (frDown in FindDialog1.Options) then
    begin
      //  ()
      StartPos  := Memo1.SelStart + Memo1.SelLength + 1;
      Match := RegEx.Match(Memo1.Lines.Text, StartPos);
    end
  else
    begin
      // t ()
      StartPos := 0;
      EndPos   := Memo1.SelStart + 1;
      Match := RegEx.Match(Memo1.Lines.Text, StartPos, EndPos);
      while Match.Success do
        begin
          // ŌɃ}b`ӏT
          dMatch := Match.NextMatch;
          if dMatch.Success then
            Match := dMatch
          else
            break;
        end;
    end;

  // L
  FindDialog1.FindText := (Sender as TFindDialog).FindText;
  ReplaceDialog1.FindText := (Sender as TFindDialog).FindText;

  // 𐳋K\փGXP[v
  Exp := TRegEx.Escape((Sender as TFindDialog).FindText);

  // "啶Əʂ" Ƀ`FbNĂȂ
  // IvV roIgnoreCase (啶ʂȂ) ǉ
  if not (frMatchCase in (Sender as TFindDialog).Options) then
    Include(Options, roIgnoreCase);

  // K\IuWFNg̐
  RegEx := TRegEx.Create(Exp, Options);
  if (frDown in (Sender as TFindDialog).Options) then
    begin
      //  ()
      StartPos  := Memo1.SelStart + Memo1.SelLength + 1;
      Match := RegEx.Match(Memo1.Lines.Text, StartPos);
    end
  else
    begin
      // t ()
      StartPos := 0;
      EndPos   := Memo1.SelStart + 1;
      Match := RegEx.Match(Memo1.Lines.Text, StartPos, EndPos);
      while Match.Success do
        begin
          // ŌɃ}b`ӏT
          dMatch := Match.NextMatch;
          if dMatch.Success then
            Match := dMatch
          else
            break;
        end;
    end;

  if Match.Success then
    begin
      // v镶񂪂
      SetFocus;
      Memo1.SelStart := Match.Index - 1;
      Memo1.SelLength := Match.Length;
    end
  else
    begin
      // v镶񂪂Ȃ
      Msg := Format('"%s" ܂B', [(Sender as TFindDialog).FindText]);
      MessageDlg(Msg, TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], -1);
    end;
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
// uCxgnh
var
  srFlgs: TReplaceFlags;
  FindText: string;
  SelectFlg: Boolean;
begin
  // L
  FindDialog1.FindText := (Sender as TFindDialog).FindText;
  ReplaceDialog1.FindText := (Sender as TFindDialog).FindText;

  // tO
  if (frReplaceAll in ReplaceDialog1.Options) then
    begin
      // [ׂĒu]
      srFlgs := [rfReplaceAll]; // ׂĒu
      if  not (frMatchCase in ReplaceDialog1.Options) then
        Include(srFlgs, rfIgnoreCase);
      Memo1.Lines.Text := StringReplace(Memo1.Lines.Text, ReplaceDialog1.FindText, ReplaceDialog1.ReplaceText, srFlgs);
    end
  else
    begin
      // [uĎ]
      srFlgs := []; // ŏ̈񂾂u
      if  not (frMatchCase in ReplaceDialog1.Options) then
        Include(srFlgs, rfIgnoreCase);
      // ς݂ǂ̔
      FindText := (Sender as TFindDialog).FindText;
      if (frMatchCase in ReplaceDialog1.Options) then
        SelectFlg := SameStr(Memo1.SelText, FindText)   // 啶ʂ
      else
        SelectFlg := SameText(Memo1.SelText, FindText); // 啶ʂȂ
      // ς݂H
      if SelectFlg then
        Memo1.SelText := ReplaceDialog1.ReplaceText;
      // 
      Dialog_Find(ReplaceDialog1);
    end;
end;

procedure TForm1.acGoToExecute(Sender: TObject);
// Action: sֈړ(G)
begin
  Form2 := TForm2.Create(Self);
  try
    // ݍsƍős Form2 ɓn
    Form2.GotoLine := Memo1.Perform(EM_LINEFROMCHAR, WPARAM(-1), 0) + 1; // 0 IWȂ̂ + 1 
    Form2.LineCount := Memo1.Perform(EM_GETLINECOUNT, 0, 0);
    // Form2 [_ŕ\
    if Form2.ShowModal = mrOK then
      begin
        // [OK] {^ꂽ
        Memo1.SelLength := 0;
        Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, Form2.GotoLine - 1, 0);
        Memo1.Perform(EM_SCROLLCARET,0 , 0);
      end;
  finally
    Form2.Free;
  end;
end;

procedure TForm1.acSelectAllExecute(Sender: TObject);
// Action: ׂđI(A)
begin
  Memo1.SelectAll;
end;

// [FORMAT] Actions

procedure TForm1.acTimeDateExecute(Sender: TObject);
// Action: tƎ(D)
begin
  Memo1.SelText := FormatDateTime('hh:nn yyyy/mm/dd', Now);
end;

procedure TForm1.acWordwrapExecute(Sender: TObject);
// Action: [EŐ܂Ԃ(W)]
const
  SB: array [Boolean] of TScrollStyle = (ssBoth, ssVertical);
begin
  Memo1.WordWrap := not Memo1.WordWrap;
  Memo1.ScrollBars := SB[Memo1.WordWrap];
  if Memo1.WordWrap then         // <-- ǉ
    StatusBar1.Visible := False; // <-- ǉ
end;

procedure TForm1.acFontExecute(Sender: TObject);
// Action: [tHg(F)...]
begin
  FontDialog1.Font := Memo1.Font;   // Memo1 ̃tHgRs[
  if FontDialog1.Execute then
    Memo1.Font := FontDialog1.Font; // FontDialog1 ̃tHgRs[
end;

// [VIEW] Actions

procedure TForm1.acStatusBarExecute(Sender: TObject);
// Action: [Xe[^Xo[(S)]
begin
  StatusBar1.Visible := not StatusBar1.Visible;
end;

// [HELP] Actions

procedure TForm1.acHelpExecute(Sender: TObject);
// Action: [wv(H)]
var
  URL: string;
begin
  URL := 'https://www.embarcadero.com/jp/products/delphi';
  ShellExecute(0, 'open', PWideChar(URL), nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.acAboutExecute(Sender: TObject);
// Action: [o[W(A)]
begin
  ShellAbout(Self.Handle, PChar(Application.Title), '', Application.Icon.Handle);
end;

// XgXV

procedure TForm1.ActionList1Update(Action: TBasicAction; var Handled: Boolean);
begin
  // [ɖ߂(U)] ̗L/
  acUndo.Enabled := Memo1.CanUndo;
  // [؂(T)] ̗L/
  acCut.Enabled := Memo1.SelLength <> 0;
  // [Rs[(C)] ̗L/
  acCopy.Enabled := Memo1.SelLength <> 0;
  // [\t(P)] ̗L/
  acPaste.Enabled := ClipBoard.HasFormat(CF_TEXT);
  // [폜(L)] ̗L/
  acDelete.Enabled := Memo1.SelLength <> 0;
  acDelete.ShortCut := 0;
  // [(F)] ̗L/
  acFind.Enabled := Memo1.Lines.Text.Length > 0;
  // [(N)] ̗L/
  acFindNext.Enabled := Memo1.Lines.Text.Length > 0;
  // [EŐ܂Ԃ(W)] ̃`FbN
  acWordwrap.Checked := Memo1.WordWrap;
  // [sֈړ(&G)] ̗L/
  acGoTo.Enabled := not Memo1.WordWrap;
  // [Xe[^Xo[(S)] ̗L/
  acStatusBar.Enabled := not Memo1.WordWrap;
  // [Xe[^Xo[(S)] ̃`FbN
  acStatusBar.Checked := StatusBar1.Visible;
end;

// \bh

function TForm1.DetectEncodingFromFile(FileName: string): Integer;
// t@C̓eGR[fBO𔻒肷
var
  MS: TMemoryStream;
  BufSize: Integer;
  B: Byte;
  Buf: TBytes;
  i, Idx, TrailByteCnt: Integer;
  UTF8Flg: Boolean;
  function UTF8TrailByteSize(Lead: Byte): Integer;
  begin
    case Lead of
      $00..$7F: Result := 0;
      $C2..$DF: Result := 1;
      $E0..$EF: Result := 2;
      $F0..$F7: Result := 3;
      $F8..$FB: Result := 4;
      $FC..$FD: Result := 5;
    else
      Result := 0;
    end;
  end;
begin
  MS := TMemoryStream.Create;
  try
    MS.LoadFromFile(FileName);

    // BOM Ȃ ANSI
    result := 0;
    if (MS.Size < 2) then
      Exit;

    // BOM 𒲂ׂĔ
    BufSize := Min(2048, MS.Size);
    SetLength(Buf, BufSize);
    MS.ReadBuffer(Buf, BufSize);
    if      (Buf[0] = $FF) and (Buf[1] = $FE) then
      result := 1
    else if (Buf[0] = $FE) and (Buf[1] = $FF) then
      result := 2
    else if (MS.Size >= 3) and (Buf[0] = $EF) and (Buf[1] = $BB)  and (Buf[2] = $BF) then
      result := 3;
    if result > 0 then  // GR[fBO肳ĂΔ
      Exit;

    // UTF-8  ANSI 𔻒
    result := 3;
    Idx := 0;
    while Idx < BufSize do
      begin
        if Buf[Idx] >= $80 then
          begin
            TrailByteCnt := UTF8TrailByteSize(Buf[Idx]);
            if TrailByteCnt = 0 then
              begin
                result := 0;
                Break;
              end;
            if (Idx + TrailByteCnt) < BufSize then
              begin
                UTF8Flg := True;
                for i:=1 to TrailByteCnt do
                  begin
                    B := Buf[Idx + i];
                    if (B < $80) or (B > $BF) then
                      begin
                        UTF8Flg := False;
                        Break;
                      end;
                  end;
                if not UTF8Flg then
                  begin
                    result := 0;
                    Break;
                  end;
              end;
            Inc(Idx, TrailByteCnt);
          end;
        Inc(Idx);
      end;
  finally
    MS.Free;
  end;
end;

procedure TForm1.DispRowCol;
var
  Row, Col: Integer;
begin
  // Xe[^Xo[ɍs/\
  Row := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
  Col := Memo1. SelStart -  Memo1.Perform(EM_LINEINDEX, WPARAM(ROW), 0);
  StatusBar1.Panels[1].Text := Format(' %dsA%d' , [Row + 1, Col + 1]);
end;

function TForm1.GetEditorEncoding: TEncoding;
// ҏW̃t@C̃GR[fBOԂ
begin
  // EncodingIndex ɂGR[fBOw
  case FEncodingIndex of
    1: result := TEncoding.Unicode;
    2: result := TEncoding.BigEndianUnicode;
    3: result := TEncoding.UTF8;
  else
    result := TEncoding.Default;
  end;
end;

function TForm1.GetTextFileName;
// ҏW̃t@CԂ
begin
  if FFileName = '' then
    result := ''
  else
    result := TPath.GetFileName(FFileName);
end;

procedure TForm1.Init(AFileName: string);
// GfB^̏
begin
 // l
  FFileName := AFileName;
  FEncodingIndex := 0;
  Memo1.Lines.Clear; // Memo1 ̒gB
  // LvVύX
  UpdateCaption;
  // s/̕\
  DispRowCol;
end;

procedure TForm1.PrintText(const HeaderStr, FooterStr: string);
// WbN
const
  DRAW_FLG = DT_NOPREFIX or DT_TOP or DT_LEFT or DT_WORDBREAK;
  CALC_FLG = DRAW_FLG or DT_CALCRECT;
var
  i, l, j, Index, LineCount, Sum, TextHeight, X_DPI, Y_DPI, PAGE_HEIGHT,
  PAPER_WIDTH, PAPER_HEIGHT, MIN_HEIGHT, Copies: Integer;
  PrintRect, CalcRect, CalcRect2, HeaderRect, FooterRect: TRect;
  Text: String;
  SL : TStringList;
  Pages: array of Integer;
  { DrawHeaderFooter End}
  procedure DrawHeaderFooter(const AStr: string; ARect: TRect; AFlgs: Integer; APage: Integer);
  var
    Flgs: Integer;
    AlignFlg: Integer;
    P: PChar;
    Str: string;
    ChangeAlign: Boolean;
  begin
    if AStr = '' then
      Exit;
    Flgs := AFlgs or DT_NOPREFIX or DT_SINGLELINE;
    AlignFlg := DT_CENTER;
    Str := '';
    P := @AStr[1];
    while (P^ <> #$00) do
      begin
        if P^ = '&' then
          begin
            Inc(P);
            if P^ = #$00 then
              Break;
            ChangeAlign := False;
            case UpCase(P^) of
              'L', 'C', 'R':
                ChangeAlign := True;
              'D':
                Str := Str + FormatDateTime('YYYY"N"M""M""', Date);
              'T':
                Str := Str + FormatDateTime('h:n:s', Time);
              'F':
                Str := Str + GetTextFileName;
              'P':
                Str := Str + APage.ToString;
              '&':
                Str := Str + '&';
            end;
            if (Str <> '') and ChangeAlign then
              begin
                DrawText(Printer.Canvas.Handle, PChar(Str), Length(Str), ARect, Flgs or AlignFlg);
                Str := '';
              end;
            case UpCase(P^) of
              'L': AlignFlg := DT_LEFT;
              'C': AlignFlg := DT_CENTER;
              'R': AlignFlg := DT_RIGHT;
            end;
          end
        else
          Str := Str + P^;
        Inc(P);
      end;
    if Str <> '' then
      begin
        DrawText(Printer.Canvas.Handle, PChar(Str), Length(Str), ARect, Flgs or AlignFlg);
        Str := '';
      end;
  end;
  { DrawHeaderFooter End}
  { DrawHeader Begin}
  procedure DrawHeader(APage: Integer);
  begin
    DrawHeaderFooter(HeaderStr, HeaderRect, DT_TOP, APage);
  end;
  { DrawHeader End}
  { DrawFooter Begin}
  procedure DrawFooter(APage: Integer);
  begin
    DrawHeaderFooter(FooterStr, FooterRect, DT_BOTTOM, APage);
  end;
  { DrawFooter End}
begin
  if not PrintDialog1.Execute then
    Exit;

  // v^ DPI
  X_DPI := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
  Y_DPI := GetDeviceCaps(Printer.Handle, LOGPIXELSY);

  // p̕ƍ
  PAPER_WIDTH  := GetDeviceCaps(Printer.Handle, PHYSICALWIDTH );
  PAPER_HEIGHT := GetDeviceCaps(Printer.Handle, PHYSICALHEIGHT);

  // ̈
  PrintRect.Top    :=                Trunc(PageSetupDialog1.MarginTop    / 2540 * Y_DPI);
  PrintRect.Left   :=                Trunc(PageSetupDialog1.MarginLeft   / 2540 * X_DPI);
  PrintRect.Bottom := PAPER_HEIGHT - Trunc(PageSetupDialog1.MarginBottom / 2540 * Y_DPI);
  PrintRect.Right  := PAPER_WIDTH  - Trunc(PageSetupDialog1.MarginRight  / 2540 * X_DPI);

  // 
  Printer.Title := GetTextFileName;
  Printer.BeginDoc;
  SetBkMode(Printer.Canvas.Handle, TRANSPARENT);
  Printer.Canvas.Font.Assign(Memo1.Font); // Memo1 ̃tHg Canvas Ɋ蓖

  Text := 'A';
  CalcRect := Rect(0, 0, Printer.PageWidth, 0);
  DrawText(Printer.Canvas.Handle, PChar(Text), Length(Text), CalcRect, CALC_FLG);
  MIN_HEIGHT := CalcRect.Bottom;

  if HeaderStr <> '' then
    begin
      HeaderRect := PrintRect;
      HeaderRect.Bottom := PrintRect.Top + MIN_HEIGHT * 2;
      PrintRect.Top := HeaderRect.Bottom;
    end;
  if FooterStr <> '' then
    begin
      FooterRect := PrintRect;
      FooterRect.Top := PrintRect.Bottom - MIN_HEIGHT * 2;
      PrintRect.Bottom := FooterRect.Top;
    end;
  PAGE_HEIGHT := PrintRect.Bottom - PrintRect.Top;

  SetLength(Pages, 1);
  SL := TStringList.Create;
  try
    SL.Text := Memo1.Lines.Text;

    // y[W̌vZ
    LineCount := 0;
    Sum := 0;
    for i:=0 to SL.Count-1 do
      begin
        Text := SL[i];
        CalcRect := PrintRect;
        CalcRect.Top    := 0;
        CalcRect.Bottom := 0;
        DrawText(Printer.Canvas.Handle, PChar(Text), Length(Text), CalcRect, CALC_FLG);
        TextHeight := Max(MIN_HEIGHT, CalcRect.Bottom);
        if (Sum + TextHeight) > PAGE_HEIGHT then
          begin
            Pages[Length(Pages)-1] := LineCount;
            SetLength(Pages, Length(Pages) + 1);
            LineCount := 0;
            Sum := 0;
          end;
        Inc(LineCount);
        Inc(Sum, TextHeight);
      end;
    LineCount := SL.Count;
    for i:=0 to Length(Pages) - 2 do
      Dec(LineCount, Pages[i]);
    Pages[Length(Pages)-1] := LineCount;

    // 
    if PrintDialog1.Collate then
      Copies := PrintDialog1.Copies // Pʂň
    else
      Copies := 1;
    for j:=1 to Copies do
      begin
        CalcRect := PrintRect;
        Index := 0;
        for l:=0 to Length(Pages) - 1 do
          begin
            // wb_
            DrawHeader(l+1);
            // eLXg
            CalcRect.Top := PrintRect.Top;
            for i:=0 to Pages[l] - 1 do
              begin
                CalcRect2 := PrintRect;
                CalcRect2.Top := 0;
                CalcRect2.Bottom := 0;
                Text := SL[Index];
                DrawText(Printer.Canvas.Handle, PChar(Text), Length(Text), CalcRect2, CALC_FLG);
                TextHeight := Max(MIN_HEIGHT, CalcRect2.Bottom);
                DrawText(Printer.Canvas.Handle, PChar(Text), Length(Text), CalcRect, DRAW_FLG);
                CalcRect.Top := CalcRect.Top + TextHeight;
                Inc(Index);
              end;
            // tb^
            DrawFooter(l+1);
            // y[W
            if (l <> (Length(Pages) - 1)) or (J <> Copies) then
              Printer.NewPage;
          end;
      end;
  finally
    SL.Free;
  end;
  Printer.EndDoc;
end;

procedure TForm1.SaveFile;
begin
  // GR[fBOw肵ĕۑ
  Memo1.Lines.SaveToFile(FFileName, GetEditorEncoding);
end;

procedure TForm1.UpdateCaption;
// LvV (t@C) ̍XV
begin
  Self.Caption := GetTextFileName + ' - ' + Application.Title;
end;

end.

